<?php
/* Autor...:  */
/* Esquema.: ALM_CajaChicaCab.xml */
/* Generado: 2020-08-18 04:21:23 */

/* Metodos de acceso a los campos de la tabla ALM_CajaChicaCab */
abstract class BaseALM_CajaChicaCabBN
{
    /* Campos de la tabla */
    private $i_IdCaja;    // IdCaja: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $d_FechaCaja;    // FechaCaja: ( no definido )
    private $d_FechaCierreCaja;    // FechaCierreCaja: ( no definido )
    private $f_MontoFondo;    // MontoFondo: ( no definido )
    private $f_MontoSaldoAnt;    // MontoSaldoAnt: ( no definido )
    private $f_MontoIngreso;    // MontoIngreso: ( no definido )
    private $f_MontoSaldoAct;    // MontoSaldoAct: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_EnUsoFlag;    // EnUsoFlag: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdCaja */
    public function setIdCaja( $i_IdCaja )
    {
        $this->i_IdCaja = $i_IdCaja;
    }

    /* Obtiene el valor del campo IdCaja */
    public function getIdCaja()
    {
        return $this->i_IdCaja;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo FechaCaja */
    public function setFechaCaja( $d_FechaCaja )
    {
        $this->d_FechaCaja = $d_FechaCaja;
    }

    /* Obtiene el valor del campo FechaCaja */
    public function getFechaCaja()
    {
        return $this->d_FechaCaja;
    }

    /* Establece el valor del campo FechaCierreCaja */
    public function setFechaCierreCaja( $d_FechaCierreCaja )
    {
        $this->d_FechaCierreCaja = $d_FechaCierreCaja;
    }

    /* Obtiene el valor del campo FechaCierreCaja */
    public function getFechaCierreCaja()
    {
        return $this->d_FechaCierreCaja;
    }

    /* Establece el valor del campo MontoFondo */
    public function setMontoFondo( $f_MontoFondo )
    {
        $this->f_MontoFondo = $f_MontoFondo;
    }

    /* Obtiene el valor del campo MontoFondo */
    public function getMontoFondo()
    {
        return $this->f_MontoFondo;
    }

    /* Establece el valor del campo MontoSaldoAnt */
    public function setMontoSaldoAnt( $f_MontoSaldoAnt )
    {
        $this->f_MontoSaldoAnt = $f_MontoSaldoAnt;
    }

    /* Obtiene el valor del campo MontoSaldoAnt */
    public function getMontoSaldoAnt()
    {
        return $this->f_MontoSaldoAnt;
    }

    /* Establece el valor del campo MontoIngreso */
    public function setMontoIngreso( $f_MontoIngreso )
    {
        $this->f_MontoIngreso = $f_MontoIngreso;
    }

    /* Obtiene el valor del campo MontoIngreso */
    public function getMontoIngreso()
    {
        return $this->f_MontoIngreso;
    }

    /* Establece el valor del campo MontoSaldoAct */
    public function setMontoSaldoAct( $f_MontoSaldoAct )
    {
        $this->f_MontoSaldoAct = $f_MontoSaldoAct;
    }

    /* Obtiene el valor del campo MontoSaldoAct */
    public function getMontoSaldoAct()
    {
        return $this->f_MontoSaldoAct;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo EnUsoFlag */
    public function setEnUsoFlag( $s_EnUsoFlag )
    {
        $this->s_EnUsoFlag = $s_EnUsoFlag;
    }

    /* Obtiene el valor del campo EnUsoFlag */
    public function getEnUsoFlag()
    {
        return $this->s_EnUsoFlag;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdCaja' => $this->getIdCaja(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'Descripcion' => $this->getDescripcion(),
            'FechaCaja' => $this->getFechaCaja(),
            'FechaCierreCaja' => $this->getFechaCierreCaja(),
            'MontoFondo' => $this->getMontoFondo(),
            'MontoSaldoAnt' => $this->getMontoSaldoAnt(),
            'MontoIngreso' => $this->getMontoIngreso(),
            'MontoSaldoAct' => $this->getMontoSaldoAct(),
            'Estado' => $this->getEstado(),
            'EnUsoFlag' => $this->getEnUsoFlag(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_CajaChicaCabBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_CajaChicaCabRs )
    {
        $o_ALM_CajaChicaCabBN = new ALM_CajaChicaCabBN();
        $o_ALM_CajaChicaCabBN->setIdCaja( ( integer ) $o_ALM_CajaChicaCabRs[ "IdCaja" ] );
        $o_ALM_CajaChicaCabBN->setIdCompania( ( integer ) $o_ALM_CajaChicaCabRs[ "IdCompania" ] );
        $o_ALM_CajaChicaCabBN->setIdSucursal( ( integer ) $o_ALM_CajaChicaCabRs[ "IdSucursal" ] );
        $o_ALM_CajaChicaCabBN->setDescripcion( $o_ALM_CajaChicaCabRs[ "Descripcion" ] );
        $o_ALM_CajaChicaCabBN->setFechaCaja( utilTimestamp::getTimestamp( $o_ALM_CajaChicaCabRs[ "FechaCaja" ], "Y-m-d H:i:s" ) );
        $o_ALM_CajaChicaCabBN->setFechaCierreCaja( utilTimestamp::getTimestamp( $o_ALM_CajaChicaCabRs[ "FechaCierreCaja" ], "Y-m-d H:i:s" ) );
        $o_ALM_CajaChicaCabBN->setMontoFondo( ( float ) $o_ALM_CajaChicaCabRs[ "MontoFondo" ] );
        $o_ALM_CajaChicaCabBN->setMontoSaldoAnt( ( float ) $o_ALM_CajaChicaCabRs[ "MontoSaldoAnt" ] );
        $o_ALM_CajaChicaCabBN->setMontoIngreso( ( float ) $o_ALM_CajaChicaCabRs[ "MontoIngreso" ] );
        $o_ALM_CajaChicaCabBN->setMontoSaldoAct( ( float ) $o_ALM_CajaChicaCabRs[ "MontoSaldoAct" ] );
        $o_ALM_CajaChicaCabBN->setEstado( $o_ALM_CajaChicaCabRs[ "Estado" ] );
        $o_ALM_CajaChicaCabBN->setEnUsoFlag( $o_ALM_CajaChicaCabRs[ "EnUsoFlag" ] );
        $o_ALM_CajaChicaCabBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_CajaChicaCabRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_CajaChicaCabBN->setUsuarioCreacion( $o_ALM_CajaChicaCabRs[ "UsuarioCreacion" ] );
        $o_ALM_CajaChicaCabBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_ALM_CajaChicaCabRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_CajaChicaCabBN->setUsuarioModificacion( $o_ALM_CajaChicaCabRs[ "UsuarioModificacion" ] );
        return $o_ALM_CajaChicaCabBN;
    }
}
?>